% GAUSSIAN ELIMINTAION AND THE MATRIX INVERSION DEMO
% IrisCores.com
close all;
clear all;
clc;

N = 5;
A = [randn(N),eye(N)];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generate a random matrix to process %
for i = 1:N
    for j = 1:N
        if(i == j)
            A(i,j) = sin(2*pi*N*i/(j*N^2));
        elseif(i < j)
            A(i,j) = rand() + sign(randn()) / (N^1);
        else
            A(i,j) = rand() + sign(randn()) / (N^1);
        end
    end
end
%%%%%%%%%%%%%%%%%
% Save Original %
A_Orig = A(:,1:N);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Forward Gaussian Elimination %
AF = GaussElimForw(A);  
%%%%%%%%%%%%%%%%%%%%%%%%%
% Backward Substitution %
AB = GaussElimBack(AF); 

%%%%%%%%%%%%%%%%%%%%%%
% Normalize Diagonal %
AG = AB;
for  i = 1:N
    AG(i,:) = AB(i,:) / AB(i,i); 
end

Man = AG(:,N+1:end) % Extract Inverse
Ref = inv(A_Orig)   % Reference
