close all;
clear all;
format bank;
clc;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Get Display Resolution %%%%%%%
Displ = groot();
ScW = Displ.ScreenSize(3);
ScH = Displ.ScreenSize(4);
FiW = 1024;
FiH = 720;

N = 32;
A = randn(N);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Make the Matrix Symmetric %
for i = 1:N
  for j = 1:N
    if(i < j)
      A(j,i) = A(i,j);
    end
  end
end

% LOOP ACROSS COLUMNS
for i = 1:N-1
    disp(['Processing: ',num2str(i),' / ',num2str(N-1)]);
    
    % LOOP ACROSS ROWS! MUST START FROM BOTTOM UP
    for j = N-1:-1:i
        CG = eye(N);
        % FORM GIVENS ROTATION MATRIX - AFFECTS ONLY 2 ROWS
        ac = A(j,i);
        bc = A(j+1,i);
        [c,s,r] = GivensRotCoef(ac,bc);
        
        % These are the default coefs 
        %r = sqrt(ac^2 + bc^2);
        %c = ac/r;
        %s = -bc/r;

        % C IS THE GIVEN'S ROTATION MATRIX
        CG(j,j) = c;
        CG(j,j + 1) = -s;
        CG(j + 1,j) = s;
        CG(j + 1,j + 1) = c;
       
        A = CG*A;
    end
end

%%%%%%%%%%%%%%%%%%%%%
%Display The Result %
figure('name','GivensRot','position',[ScW/2-FiW/2,ScH/2-FiH/2,FiW,FiH]);
imagesc(A);
