#pragma once
#include "DataTypes.h"
#include <vector>
using namespace QNSwift;
using namespace std;

/****************************************************************************
 * @brief: Memory Engine Mages the Used buffer across computation
 * NOTE: Could be improved. THere is no need to search all available buffers
 ****************************************************************************/

class MemEngine {
private:
	// MAIN MEMORY MANAGING BUFFERS
	vector<DeviceArray*> DevBuffers;
	vector<HostArray*> HostBuffers;
	DeviceArray *CreateDevRealBuffer( Dimensions Dims );
	DeviceArray *CreateDevRealBuffer( size_t Size );
	HostArray *CreateHostRealBuffer( Dimensions Dims );
	HostArray *CreateHostRealBuffer( size_t Size );
	int DevUniqueIDToIndex( int UniqueID);
	int HostUniqueIDToIndex( int UniqueID );
	int UniqueID;

public:
	MemEngine();
	~MemEngine();

	DeviceArray *GetDeviceArray( Dimensions Dims );					// GET ARRAY WITH DEFINED DIMENSIONS
	DeviceArray *GetDeviceArray( size_t Size );						// GET ARRAY WITH DEFINED SIZE
	void SetDeviceArrayAvailability( DeviceArray *Buf,bool Avail );	// MAKE THE SELECTED ARRAY UNAVILABLE
	void SetDeviceArrayAvailability( int IID,bool Avail );			// SETS THE CORRESPONDING ARRAY UNAVAILABLE
	void RemoveDeviceArray( DeviceArray *Buf );						// DELETE THE SELECTED ARRAY
	void RemoveDeviceArray( int IID );								// DELETE THE SELECTED ARRAY

	HostArray *GetHostArray( Dimensions Dims );						// GET ARRAY WITH DEFINED DIMENSIONS
	HostArray *GetHostArray( size_t Size );							// GET ARRAY WITH DEFINED SIZE
	void SetHostArrayAvailability( HostArray *Buf, bool Avail );	// MAKE THE SELECTED ARRAY UNAVILABLE
	void SetHostArrayAvailability( int IID, bool Avail );			// SETS THE CORRESPONDING ARRAY UNAVAILABLE
	void RemoveHostArray( HostArray *Buf );							// DELETE THE SELECTED ARRAY
	void RemoveHostArray( int IID );								// DELETE THE SELECTED ARRAY
};
